<template lang="pug">
.input.taginput( :class='bindClass' )
	b-tags
		b-tag( v-for='(tag, i) in modelValue' :size='size' :key='i' @addonClick='removeTag(i)' ) {{ tag }}
			template( v-slot:addon )
				span.icon.is-small
					i.fa-solid.fa-xmark
		form.control.has-icons-left.is-flex.is-align-items-center( @submit.prevent='addTag' )
			input.input( :class='bindClass' v-model='newTag' @blur='addTag' )
			span.icon.is-small.is-left
				i.fa-solid.fa-angles-right
</template>

<script setup>
	import BTags from "@/components/tags/Tags.vue"
	import BTag from "@/components/tags/Tag.vue"

	import { computed, onMounted, ref } from "vue"

	const props = defineProps({
		modelValue: {
			type: Array,
			default: () => []
		},
		size: {
			type: String,
			default: "",
			validator: val => ["", "small", "normal", "medium", "large"].includes(val)
		}
	})
	const emit = defineEmits([ "update:modelValue" ])

	const newTag = ref("")
	
	const bindClass = computed(() => [
		props.size ? `is-${props.size}` : ""
	])

	const addTag = () => {
		let exist = props.modelValue.find(tag => tag === newTag.value)

		if (!newTag.value || exist) return newTag.value = ""

		let data = props.modelValue
		data.push(newTag.value)
		newTag.value = ""
		emit("update:modelValue", data)
	}

	const removeTag = i => {
		let data = props.modelValue
		data.splice(i, 1)
		emit("update:modelValue", data)
	}

	onMounted(() => {
		if (!props.modelValue) emit("update:modelValue", [])
	})
</script>

<style lang="scss" scoped>
	.taginput {
		height: unset;
	}
	input.input {
		height: unset;
		box-shadow: none;
		background: transparent;
		border: unset;
		padding: 0;
		padding-left: calc(2.5rem - .5rem - 1px)!important;
		&.is-small {
			&+.icon {
				height: 1rem!important;
			}
		}
	}
	span.icon {
		width: 1.5rem!important;
		height: 100%!important;
		margin: auto 0;
		top: 0;
		bottom: 0;
	}
	form.control {
		flex: 1;
	}
</style>